MultiplanParser Class Reference documentation

MultiplanParser Class Referencefinal

the main class to read a Multiplan document More...

`#include <MultiplanParser.hxx>`

Inheritance diagram for MultiplanParser:

## Public Member Functions
| MultiplanParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~MultiplanParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGSpreadsheetInterface *documentInterface) final
| the main parse function
Public Member Functions inherited from MWAWSpreadsheetParser
| ~MWAWSpreadsheetParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | createDocument (librevenge::RVNGSpreadsheetInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones
bool | readColumnsPos ()
| read the columns limits pos
bool | readHeaderFooter ()
| read the header/footer strings, ...
bool | readPrinterInfo ()
| read the printer information
bool | readPrinterMessage ()
| read the printer message
bool | readZonesList ()
| read the spreadsheet zone list
bool | readZone1 (MWAWEntry const &entry)
| read an unknown zone: two blocks of 60 bytes
bool | readCellDataPosition (MWAWEntry const &entry)
| read the cell data position
bool | readLink (int pos, MWAWCellContent::FormulaInstruction &instruction)
| read a link given a position
bool | readLinkFilename (int pos, MWAWCellContent::FormulaInstruction &instruction)
| read a link filename
bool | readSharedData (int pos, int cellType, MWAWVec2i const &cellPos, MWAWCellContent &content)
| read a shared data
bool | readName (int pos, MWAWCellContent::FormulaInstruction &instruction)
| reads a name and returns the cell's instruction
bool | readZoneB ()
| read an unknown zone
bool | readZoneC ()
| read an unknown zone
bool | sendSpreadsheet ()
| try to send the main spreadsheet
bool | sendText (MWAWEntry const &entry)
| try to send a text zone
bool | sendCell (MWAWVec2i const &cellPos, int pos)
| try to send a cell
bool | readDouble (double &value)
| try to read a double value
bool | readFormula (MWAWVec2i const &cellPos, std::vector< MWAWCellContent::FormulaInstruction > &formula, long endPos, std::string &extra)
| try to read a formula
Protected Member Functions inherited from MWAWSpreadsheetParser
| MWAWSpreadsheetParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWSpreadsheetParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< MultiplanParserInternal::State > | m_state
| the state

## Friends
class | MultiplanParserInternal::SubDocument

## Detailed Description

the main class to read a Multiplan document

Note
  need more files to be sure to treat all documents

## Constructor & Destructor Documentation

## ◆ MultiplanParser()

MultiplanParser::MultiplanParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~MultiplanParser()

MultiplanParser::~MultiplanParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool MultiplanParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by MultiplanParserInternal::SubDocument, and parse().

## ◆ createDocument()

void MultiplanParser::createDocument | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by MultiplanParserInternal::SubDocument, and parse().

## ◆ createZones()

bool MultiplanParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by MultiplanParserInternal::SubDocument, and parse().

## ◆ parse()

void MultiplanParser::parse | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| finalvirtual

the main parse function

Implements MWAWSpreadsheetParser.

Referenced by MultiplanParserInternal::SubDocument.

## ◆ readCellDataPosition()

bool MultiplanParser::readCellDataPosition | ( | MWAWEntry const & | entry | ) |
| protected

read the cell data position

Referenced by MultiplanParserInternal::SubDocument, and readZonesList().

## ◆ readColumnsPos()

bool MultiplanParser::readColumnsPos | ( |  | ) |
| protected

read the columns limits pos

Referenced by createZones(), and MultiplanParserInternal::SubDocument.

## ◆ readDouble()

bool MultiplanParser::readDouble | ( | double & | value | ) |
| protected

try to read a double value

Referenced by MultiplanParserInternal::SubDocument, readFormula(), readSharedData(), and sendCell().

## ◆ readFormula()

bool MultiplanParser::readFormula | ( | MWAWVec2i const & | cellPos,
|  | std::vector< MWAWCellContent::FormulaInstruction > & | formula,
|  | long | endPos,
|  | std::string & | extra )
| protected

try to read a formula

Referenced by MultiplanParserInternal::SubDocument, readSharedData(), and sendCell().

## ◆ readHeaderFooter()

bool MultiplanParser::readHeaderFooter | ( |  | ) |
| protected

read the header/footer strings, ...

Referenced by createZones(), and MultiplanParserInternal::SubDocument.

## ◆ readLink()

bool MultiplanParser::readLink | ( | int | pos,
|  | MWAWCellContent::FormulaInstruction & | instruction )
| protected

read a link given a position

Referenced by MultiplanParserInternal::SubDocument, and readFormula().

## ◆ readLinkFilename()

bool MultiplanParser::readLinkFilename | ( | int | pos,
|  | MWAWCellContent::FormulaInstruction & | instruction )
| protected

read a link filename

Referenced by MultiplanParserInternal::SubDocument, and readLink().

## ◆ readName()

bool MultiplanParser::readName | ( | int | pos,
|  | MWAWCellContent::FormulaInstruction & | instruction )
| protected

reads a name and returns the cell's instruction

Referenced by MultiplanParserInternal::SubDocument, and readFormula().

## ◆ readPrinterInfo()

bool MultiplanParser::readPrinterInfo | ( |  | ) |
| protected

read the printer information

Referenced by createZones(), and MultiplanParserInternal::SubDocument.

## ◆ readPrinterMessage()

bool MultiplanParser::readPrinterMessage | ( |  | ) |
| protected

read the printer message

Referenced by createZones(), and MultiplanParserInternal::SubDocument.

## ◆ readSharedData()

bool MultiplanParser::readSharedData | ( | int | pos,
|  | int | cellType,
|  | MWAWVec2i const & | cellPos,
|  | MWAWCellContent & | content )
| protected

read a shared data

Referenced by MultiplanParserInternal::SubDocument, and sendCell().

## ◆ readZone1()

bool MultiplanParser::readZone1 | ( | MWAWEntry const & | entry | ) |
| protected

read an unknown zone: two blocks of 60 bytes

Referenced by MultiplanParserInternal::SubDocument, and readZonesList().

## ◆ readZoneB()

bool MultiplanParser::readZoneB | ( |  | ) |
| protected

read an unknown zone

Referenced by createZones(), and MultiplanParserInternal::SubDocument.

## ◆ readZoneC()

bool MultiplanParser::readZoneC | ( |  | ) |
| protected

read an unknown zone

Referenced by createZones(), and MultiplanParserInternal::SubDocument.

## ◆ readZonesList()

bool MultiplanParser::readZonesList | ( |  | ) |
| protected

read the spreadsheet zone list

Referenced by createZones(), and MultiplanParserInternal::SubDocument.

## ◆ sendCell()

bool MultiplanParser::sendCell | ( | MWAWVec2i const & | cellPos,
|  | int | pos )
| protected

try to send a cell

Referenced by MultiplanParserInternal::SubDocument, and sendSpreadsheet().

## ◆ sendSpreadsheet()

bool MultiplanParser::sendSpreadsheet | ( |  | ) |
| protected

try to send the main spreadsheet

Referenced by MultiplanParserInternal::SubDocument, and parse().

## ◆ sendText()

bool MultiplanParser::sendText | ( | MWAWEntry const & | entry | ) |
| protected

try to send a text zone

Referenced by MultiplanParserInternal::SubDocument.

## Friends And Related Symbol Documentation

## ◆ MultiplanParserInternal::SubDocument

friend class MultiplanParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<MultiplanParserInternal::State> MultiplanParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), MultiplanParser(), readCellDataPosition(), readColumnsPos(), readFormula(), readHeaderFooter(), readLink(), readLinkFilename(), readName(), readPrinterInfo(), readPrinterMessage(), readSharedData(), readZoneB(), readZonesList(), sendCell(), sendSpreadsheet(), and sendText().

The documentation for this class was generated from the following files:

- MultiplanParser.hxx
- MultiplanParser.cxx